diff --git a/python/mozbuild/mozbuild/frontend/sandbox.py b/python/mozbuild/mozbuild/frontend/sandbox.py
index 3638ec807c..6f51cbae0c 100644
--- a/python/mozbuild/mozbuild/frontend/sandbox.py
+++ b/python/mozbuild/mozbuild/frontend/sandbox.py
@@ -17,7 +17,6 @@ KeyError are machine parseable. This machine-friendly data is used to present
 user-friendly error messages in the case of errors.
 """
 
-from __future__ import absolute_import, unicode_literals
 
 import os
 import sys
@@ -34,12 +33,11 @@ from mozpack.files import FileFinder
 default_finder = FileFinder('/', find_executables=False)
 
 
-def alphabetical_sorted(iterable, cmp=None, key=lambda x: x.lower(),
-                        reverse=False):
+def alphabetical_sorted(iterable, key=lambda x: x.lower(), reverse=False):
     """sorted() replacement for the sandbox, ordering alphabetically by
     default.
     """
-    return sorted(iterable, cmp, key, reverse)
+    return sorted(iterable, key=key, reverse=reverse)
 
 
 class SandboxError(Exception):
@@ -115,10 +113,10 @@ class Sandbox(dict):
     def __init__(self, context, builtins=None, finder=default_finder):
         """Initialize a Sandbox ready for execution.
         """
-        self._builtins = ReadOnlyDict(
-            (builtins or self.BUILTINS).viewitems() |
-            {b: __builtins__[b] for b in ('__build_class__',)
-             if b in __builtins__}.viewitems())
+        _merged_builtins = dict(builtins or self.BUILTINS)
+        _merged_builtins.update({b: __builtins__[b] for b in ('__build_class__',)
+             if b in __builtins__})
+        self._builtins = ReadOnlyDict(_merged_builtins)
         dict.__setitem__(self, '__builtins__', self._builtins)
 
         assert isinstance(self._builtins, ReadOnlyDict)
@@ -154,6 +152,8 @@ class Sandbox(dict):
 
         try:
             source = self._finder.get(path).read()
+            if isinstance(source, bytes):
+                source = source.decode('utf-8')
         except Exception as e:
             raise SandboxLoadError(self._context.source_stack,
                 sys.exc_info()[2], read_error=path)
diff --git a/python/mozbuild/mozbuild/html_build_viewer.py b/python/mozbuild/mozbuild/html_build_viewer.py
index 5151f04a48..fec427ef9a 100644
--- a/python/mozbuild/mozbuild/html_build_viewer.py
+++ b/python/mozbuild/mozbuild/html_build_viewer.py
@@ -4,16 +4,15 @@
 
 # This module contains code for running an HTTP server to view build info.
 
-from __future__ import absolute_import, unicode_literals
 
-import BaseHTTPServer
+import http.server
 import json
 import os
 
 import requests
 
 
-class HTTPHandler(BaseHTTPServer.BaseHTTPRequestHandler):
+class HTTPHandler(http.server.BaseHTTPRequestHandler):
     def do_GET(self):
         s = self.server.wrapper
         p = self.path
@@ -82,7 +81,7 @@ class HTTPHandler(BaseHTTPServer.BaseHTTPRequestHandler):
             self.wfile.write(fh.read())
 
 
-class BuildViewerServer(object):
+class BuildViewerServer:
     def __init__(self, address='localhost', port=0):
         # TODO use pkg_resources to obtain HTML resources.
         pkg_dir = os.path.dirname(os.path.abspath(__file__))
@@ -92,7 +91,7 @@ class BuildViewerServer(object):
         self.doc_root = doc_root
         self.json_files = {}
 
-        self.server = BaseHTTPServer.HTTPServer((address, port), HTTPHandler)
+        self.server = http.server.HTTPServer((address, port), HTTPHandler)
         self.server.wrapper = self
         self.do_shutdown = False
 
diff --git a/python/mozbuild/mozbuild/jar.py b/python/mozbuild/mozbuild/jar.py
index 98333482b9..6e433978a0 100644
--- a/python/mozbuild/mozbuild/jar.py
+++ b/python/mozbuild/mozbuild/jar.py
@@ -8,16 +8,15 @@ processing jar.mn files.
 See the documentation for jar.mn on MDC for further details on the format.
 '''
 
-from __future__ import absolute_import
 
 import sys
 import os
 import errno
 import re
 import logging
-from time import localtime
+import calendar
 from MozZipFile import ZipFile
-from cStringIO import StringIO
+from io import StringIO
 from collections import defaultdict
 
 from mozbuild.preprocessor import Preprocessor
@@ -59,8 +58,7 @@ class ZipEntry(object):
 def getModTime(aPath):
     if not os.path.isfile(aPath):
         return 0
-    mtime = os.stat(aPath).st_mtime
-    return localtime(mtime)
+    return os.stat(aPath).st_mtime
 
 
 class JarManifestEntry(object):
@@ -95,20 +93,20 @@ class DeprecatedJarManifest(Exception): pass
 
 class JarManifestParser(object):
 
-    ignore = re.compile('\s*(\#.*)?$')
+    ignore = re.compile(r'\s*(\#.*)?$')
     jarline = re.compile('''
         (?:
-            (?:\[(?P<base>[\w\d.\-\_\\\/{}@]+)\]\s*)? # optional [base/path]
-            (?P<jarfile>[\w\d.\-\_\\\/{}]+).jar\:    # filename.jar:
+            (?:\\[(?P<base>[\\w\\d.\\-\\_\\\\/{}@]+)\\]\\s*)? # optional [base/path]
+            (?P<jarfile>[\\w\\d.\\-\\_\\\\/{}]+).jar\\:    # filename.jar:
         |
-            (?:\s*(\#.*)?)                           # comment
-        )\s*$                                        # whitespaces
+            (?:\\s*(\\#.*)?)                           # comment
+        )\\s*$                                        # whitespaces
         ''', re.VERBOSE)
-    relsrcline = re.compile('relativesrcdir\s+(?P<relativesrcdir>.+?):')
-    regline = re.compile('\%\s+(.*)$')
-    entryre = '(?P<optPreprocess>\*)?(?P<optOverwrite>\+?)\s+'
+    relsrcline = re.compile(r'relativesrcdir\s+(?P<relativesrcdir>.+?):')
+    regline = re.compile(r'\%\s+(.*)$')
+    entryre = r'(?P<optPreprocess>\*)?(?P<optOverwrite>\+?)\s+'
     entryline = re.compile(entryre
-                           + '(?P<output>[\w\d.\-\_\\\/\+\@]+)\s*(\((?P<locale>\%?)(?P<source>[\w\d.\-\_\\\/\@\*]+)\))?\s*$'
+                           + '(?P<output>[\\w\\d.\\-\\_\\\\/\\+\\@]+)\\s*(\\((?P<locale>\\%?)(?P<source>[\\w\\d.\\-\\_\\\\/\\@\\*]+)\\))?\\s*$'
                            )
 
     def __init__(self):
@@ -274,7 +272,7 @@ class JarMaker(object):
                                 chromebasepath.format(''), register)
             if jarname != 'chrome':
                 addEntriesToListFile(chromeManifest,
-                                     ['manifest {0}.manifest'.format(jarname)])
+                                     ['manifest {}.manifest'.format(jarname)])
         if self.useChromeManifest:
             chromebase = os.path.dirname(jarname) + '/'
             self.updateManifest(chromeManifest,
@@ -302,9 +300,9 @@ class JarMaker(object):
         '''updateManifest replaces the % in the chrome registration entries
         with the given chrome base path, and updates the given manifest file.
         '''
-        myregister = dict.fromkeys(map(lambda s: s.replace('%',
-            chromebasepath), register))
-        addEntriesToListFile(manifestPath, myregister.iterkeys())
+        myregister = dict.fromkeys([s.replace('%',
+            chromebasepath) for s in register])
+        addEntriesToListFile(manifestPath, myregister.keys())
 
     def makeJar(self, infile, jardir):
         '''makeJar is the main entry point to JarMaker.
@@ -322,7 +320,7 @@ class JarMaker(object):
         elif self.relativesrcdir:
             self.localedirs = \
                 self.generateLocaleDirs(self.relativesrcdir)
-        if isinstance(infile, basestring):
+        if isinstance(infile, str):
             logging.info('processing ' + infile)
             self.sourcedirs.append(_normpath(os.path.dirname(infile)))
         pp = self.pp.clone()
@@ -372,7 +370,7 @@ class JarMaker(object):
             jarfilepath = jarfile + '.jar'
             try:
                 os.makedirs(os.path.dirname(jarfilepath))
-            except OSError, error:
+            except OSError as error:
                 if error.errno != errno.EEXIST:
                     raise
             jf = ZipFile(jarfilepath, 'a', lock=True)
@@ -445,7 +443,7 @@ class JarMaker(object):
         if realsrc is None:
             if jf is not None:
                 jf.close()
-            raise RuntimeError('File "{0}" not found in {1}'.format(src,
+            raise RuntimeError('File "{}" not found in {}'.format(src,
                                ', '.join(src_base)))
 
         if out in self._seen_output:
@@ -458,9 +456,15 @@ class JarMaker(object):
             pp = self.pp.clone()
             if src[-4:] == '.css':
                 pp.setMarker('%')
-            pp.out = outf
+            buf = StringIO()
+            pp.out = buf
             pp.do_include(inf)
             pp.warnUnused(realsrc)
+            content = buf.getvalue()
+            if hasattr(outf, 'mode') and 'b' in outf.mode:
+                outf.write(content.encode('utf-8'))
+            else:
+                outf.write(content)
             outf.close()
             inf.close()
             return
@@ -489,7 +493,7 @@ class JarMaker(object):
         def getDestModTime(self, aPath):
             try:
                 info = self.jarfile.getinfo(aPath)
-                return info.date_time
+                return float(calendar.timegm(info.date_time + (0, 0, -1)))
             except:
                 return 0
 
@@ -514,7 +518,7 @@ class JarMaker(object):
             # remove previous link or file
             try:
                 os.remove(out)
-            except OSError, e:
+            except OSError as e:
                 if e.errno != errno.ENOENT:
                     raise
             return open(out, 'wb')
@@ -525,7 +529,7 @@ class JarMaker(object):
             if not os.path.isdir(outdir):
                 try:
                     os.makedirs(outdir)
-                except OSError, error:
+                except OSError as error:
                     if error.errno != errno.EEXIST:
                         raise
             return out
@@ -541,7 +545,7 @@ class JarMaker(object):
             # remove previous link or file
             try:
                 os.remove(out)
-            except OSError, e:
+            except OSError as e:
                 if e.errno != errno.ENOENT:
                     raise
             if sys.platform != 'win32':
diff --git a/python/mozbuild/mozbuild/mach_commands.py b/python/mozbuild/mozbuild/mach_commands.py
index 3a81b03be2..ade3779ab2 100644
--- a/python/mozbuild/mozbuild/mach_commands.py
+++ b/python/mozbuild/mozbuild/mach_commands.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
 import argparse
 import errno
@@ -124,7 +123,7 @@ class TerminalLoggingHandler(logging.Handler):
             self.release()
 
 
-class BuildProgressFooter(object):
+class BuildProgressFooter:
     """Handles display of a build progress indicator in a terminal.
 
     When mach builds inside a blessings-supported terminal, it will render
@@ -550,7 +549,7 @@ class Build(MachCommandBase):
             ppcheck_script = None
         
         if ppcheck_script:
-            ppcheck_cmd = [which.which("python2.7"), ppcheck_script, ppcheck_path]
+            ppcheck_cmd = [sys.executable, ppcheck_script, ppcheck_path]
             ppcheck_result = subprocess.call(ppcheck_cmd, cwd=self.topsrcdir)
         
         if not ppcheck_script or ppcheck_result: 
@@ -575,7 +574,7 @@ class Build(MachCommandBase):
         # Only print build status messages when we have an active
         # monitor.
         if not buildstatus_messages:
-            append_env[b'NO_BUILDSTATUS_MESSAGES'] =  b'1'
+            append_env['NO_BUILDSTATUS_MESSAGES'] = '1'
         status = self._run_make(srcdir=True, filename='client.mk',
             target='configure', line_handler=line_handler, log=False,
             print_directory=False, allow_parallel=False, ensure_exit_code=False,
@@ -1471,7 +1470,7 @@ class MachDebug(MachCommandBase):
             if verbose:
                 print('config substitutions:', file=out)
                 for k in sorted(config.substs):
-                    print('\t%s: %s' % (k, config.substs[k]), file=out)
+                    print('\t{}: {}'.format(k, config.substs[k]), file=out)
 
                 print('config defines:', file=out)
                 for k in sorted(config.defines):
diff --git a/python/mozbuild/mozbuild/makeutil.py b/python/mozbuild/mozbuild/makeutil.py
index fcd45bed23..f2ea2eccd5 100644
--- a/python/mozbuild/mozbuild/makeutil.py
+++ b/python/mozbuild/mozbuild/makeutil.py
@@ -2,15 +2,14 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import os
 import re
-from types import StringTypes
-from collections import Iterable
+StringTypes = (str,)
+from collections.abc import Iterable
 
 
-class Makefile(object):
+class Makefile:
     '''Provides an interface for writing simple makefiles
 
     Instances of this class are created, populated with rules, then
@@ -56,7 +55,7 @@ class Makefile(object):
             guard.dump(fh)
 
 
-class _SimpleOrderedSet(object):
+class _SimpleOrderedSet:
     '''
     Simple ordered set, specialized for used in Rule below only.
     It doesn't expose a complete API, and normalizes path separators
@@ -88,7 +87,7 @@ class _SimpleOrderedSet(object):
         self._list.extend(added)
 
 
-class Rule(object):
+class Rule:
     '''Class handling simple rules in the form:
            target1 target2 ... : dep1 dep2 ...
                    command1
diff --git a/python/mozbuild/mozbuild/milestone.py b/python/mozbuild/mozbuild/milestone.py
index 3ef55d540d..6291ef013c 100644
--- a/python/mozbuild/mozbuild/milestone.py
+++ b/python/mozbuild/mozbuild/milestone.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
+from __future__ import print_function
 import argparse
 import os
 import re
@@ -63,14 +63,14 @@ def main(args):
 
     if options.uaversion:
         # Only expose the major+minor milestone in the UA string.
-        uaversion = "%s.%s" % (get_milestone_major(milestone),
+        uaversion = "{}.{}".format(get_milestone_major(milestone),
                                get_milestone_minor(milestone))
         print(uaversion)
 
     elif options.symbolversion:
         # Only expose major milestone and alpha version. Used for symbol
         # versioning on Linux.
-        symbolversion = "%s%s" % (get_milestone_major(milestone),
+        symbolversion = "{}{}".format(get_milestone_major(milestone),
                                   get_milestone_ab_with_num(milestone))
         print(symbolversion)
     else:
diff --git a/python/mozbuild/mozbuild/mozconfig.py b/python/mozbuild/mozbuild/mozconfig.py
index b2d91561e8..4d2fcdf624 100644
--- a/python/mozbuild/mozbuild/mozconfig.py
+++ b/python/mozbuild/mozbuild/mozconfig.py
@@ -2,8 +2,8 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, unicode_literals
 
+from __future__ import print_function
 import filecmp
 import os
 import re
@@ -57,10 +57,10 @@ class MozconfigLoadException(Exception):
         Exception.__init__(self, message)
 
 
-class MozconfigLoader(object):
+class MozconfigLoader:
     """Handles loading and parsing of mozconfig files."""
 
-    RE_MAKE_VARIABLE = re.compile('''
+    RE_MAKE_VARIABLE = re.compile(r'''
         ^\s*                    # Leading whitespace
         (?P<var>[a-zA-Z_0-9]+)  # Variable name
         \s* [?:]?= \s*          # Assignment operator surrounded by optional
@@ -116,7 +116,7 @@ class MozconfigLoader(object):
                 potential_roots = [self.topsrcdir, os.getcwd()]
                 # Attempt to eliminate duplicates for e.g.
                 # self.topsrcdir == os.curdir.
-                potential_roots = set(os.path.abspath(p) for p in potential_roots)
+                potential_roots = {os.path.abspath(p) for p in potential_roots}
                 existing = [root for root in potential_roots
                             if os.path.exists(os.path.join(root, env_path))]
                 if len(existing) > 1:
diff --git a/python/mozbuild/mozbuild/mozinfo.py b/python/mozbuild/mozbuild/mozinfo.py
index d0087d31a8..00e7f9382e 100755
--- a/python/mozbuild/mozbuild/mozinfo.py
+++ b/python/mozbuild/mozbuild/mozinfo.py
@@ -5,7 +5,6 @@
 # This module produces a JSON file that provides basic build info and
 # configuration metadata.
 
-from __future__ import absolute_import
 
 import os
 import re
@@ -128,7 +127,7 @@ def write_mozinfo(file, config, env=os.environ):
     and what keys are produced.
     """
     build_conf = build_dict(config, env)
-    if isinstance(file, basestring):
-        file = open(file, 'wb')
+    if isinstance(file, str):
+        file = open(file, 'w')
 
     json.dump(build_conf, file, sort_keys=True, indent=4)
diff --git a/python/mozbuild/mozbuild/preprocessor.py b/python/mozbuild/mozbuild/preprocessor.py
index 2e7eed1ca6..66818a9c8c 100644
--- a/python/mozbuild/mozbuild/preprocessor.py
+++ b/python/mozbuild/mozbuild/preprocessor.py
@@ -1,7 +1,7 @@
 # This Source Code Form is subject to the terms of the Mozilla Public
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
-"""
+r"""
 This is a very primitive line based preprocessor, for times when using
 a C preprocessor isn't an option.
 
@@ -27,7 +27,8 @@ import os
 import re
 from optparse import OptionParser
 import errno
-from makeutil import Makefile
+from .makeutil import Makefile
+from functools import reduce
 
 # hack around win32 mangling our line endings
 # http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/65443
@@ -56,7 +57,7 @@ class Expression:
         self.__ignore_whitespace()
         self.e = self.__get_logical_or()
         if self.content:
-            raise Expression.ParseError, self
+            raise Expression.ParseError(self)
 
     def __get_logical_or(self):
         """
@@ -126,7 +127,7 @@ class Expression:
         Production: '!'? value
         """
         # eat whitespace right away, too
-        not_ws = re.match('!\s*', self.content)
+        not_ws = re.match(r'!\s*', self.content)
         if not not_ws:
             return self.__get_value()
         rv = Expression.__AST('not')
@@ -136,14 +137,14 @@ class Expression:
         return rv
 
     def __get_value(self):
-        """
+        r"""
         Production: ( [0-9]+ | 'defined(' \w+ ')' | \w+ )
         Note that the order is important, and the expression is kind-of
         ambiguous as \w includes 0-9. One could make it unambiguous by
         removing 0-9 from the first char of a string literal.
         """
         rv = None
-        m = re.match('defined\s*\(\s*(\w+)\s*\)', self.content)
+        m = re.match(r'defined\s*\(\s*(\w+)\s*\)', self.content)
         if m:
             word_len = m.end()
             rv = Expression.__ASTLeaf('defined', m.group(1))
@@ -153,17 +154,17 @@ class Expression:
                 value = int(self.content[:word_len])
                 rv = Expression.__ASTLeaf('int', value)
             else:
-                word_len = re.match('\w*', self.content).end()
+                word_len = re.match(r'\w*', self.content).end()
                 if word_len:
                     rv = Expression.__ASTLeaf('string', self.content[:word_len])
                 else:
-                    raise Expression.ParseError, self
+                    raise Expression.ParseError(self)
         self.__strip(word_len)
         self.__ignore_whitespace()
         return rv
 
     def __ignore_whitespace(self):
-        ws_len = re.match('\s*', self.content).end()
+        ws_len = re.match(r'\s*', self.content).end()
         self.__strip(ws_len)
         return
 
@@ -196,7 +197,7 @@ class Expression:
                 return left and right
             elif tok[1].value == '||':
                 return left or right
-            raise Expression.ParseError, self
+            raise Expression.ParseError(self)
 
         # Mapping from token types to evaluator functions
         # Apart from (non-)equality, all these can be simple lambda forms.
@@ -230,7 +231,7 @@ class Expression:
         def __repr__(self):
             return self.value.__repr__()
 
-    class ParseError(StandardError):
+    class ParseError(Exception):
         """
         Error raised when parsing fails.
         It has two members, offset and content, which give the offset of the
@@ -240,7 +241,7 @@ class Expression:
             self.offset = expression.offset
             self.content = expression.content[:3]
         def __str__(self):
-            return 'Unexpected content at offset {0}, "{1}"'.format(self.offset,
+            return 'Unexpected content at offset {}, "{}"'.format(self.offset,
                                                                     self.content)
 
 class Context(dict):
@@ -278,7 +279,7 @@ class Preprocessor:
         self.context = Context()
         for k,v in {'FILE': '',
                     'LINE': 0,
-                    'DIRECTORY': os.path.abspath('.')}.iteritems():
+                    'DIRECTORY': os.path.abspath('.')}.items():
             self.context[k] = v
         self.actionLevel = 0
         self.disableLevel = 0
@@ -292,25 +293,25 @@ class Preprocessor:
         self.cmds = {}
         for cmd, level in {'define': 0,
                            'undef': 0,
-                           'if': sys.maxint,
-                           'ifdef': sys.maxint,
-                           'ifndef': sys.maxint,
+                           'if': sys.maxsize,
+                           'ifdef': sys.maxsize,
+                           'ifndef': sys.maxsize,
                            'else': 1,
                            'elif': 1,
                            'elifdef': 1,
                            'elifndef': 1,
-                           'endif': sys.maxint,
+                           'endif': sys.maxsize,
                            'expand': 0,
                            'literal': 0,
                            'filter': 0,
                            'unfilter': 0,
                            'include': 0,
                            'includesubst': 0,
-                           'error': 0}.iteritems():
+                           'error': 0}.items():
             self.cmds[cmd] = (level, getattr(self, 'do_' + cmd))
         self.out = sys.stdout
         self.setMarker(marker)
-        self.varsubst = re.compile('@(?P<VAR>\w+)@', re.U)
+        self.varsubst = re.compile(r'@(?P<VAR>\w+)@', re.U)
         self.includes = set()
         self.silenceMissingDirectiveWarnings = False
         if defines:
@@ -319,9 +320,9 @@ class Preprocessor:
     def warnUnused(self, file):
         msg = None
         if self.actionLevel == 0 and not self.silenceMissingDirectiveWarnings:
-            sys.stderr.write('{0}: WARNING: no preprocessor directives found\n'.format(file))
+            sys.stderr.write('{}: WARNING: no preprocessor directives found\n'.format(file))
         elif self.actionLevel == 1:
-            sys.stderr.write('{0}: WARNING: no useful preprocessor directives found\n'.format(file))
+            sys.stderr.write('{}: WARNING: no useful preprocessor directives found\n'.format(file))
         pass
 
     def setMarker(self, aMarker):
@@ -332,7 +333,7 @@ class Preprocessor:
         """
         self.marker = aMarker
         if aMarker:
-            self.instruction = re.compile('{0}(?P<cmd>[a-z]+)(?:\s(?P<args>.*))?$'
+            self.instruction = re.compile(r'{}(?P<cmd>[a-z]+)(?:\s(?P<args>.*))?$'
                                           .format(aMarker),
                                           re.U)
             self.comment = re.compile(aMarker, re.U)
@@ -443,7 +444,7 @@ class Preprocessor:
                 except OSError as error:
                     if error.errno != errno.EEXIST:
                         raise
-            return open(path, 'wb')
+            return open(path, 'w')
 
         p = self.getCommandLineParser()
         options, args = p.parse_args(args=args)
@@ -462,7 +463,7 @@ class Preprocessor:
                 raise Preprocessor.Error(self, "--depend doesn't work with stdout",
                                          None)
             try:
-                from makeutil import Makefile
+                from .makeutil import Makefile
             except:
                 raise Preprocessor.Error(self, "--depend requires the "
                                                "mozbuild.makeutil module", None)
@@ -470,7 +471,7 @@ class Preprocessor:
 
         if args:
             for f in args:
-                with open(f, 'rU') as input:
+                with open(f, 'r') as input:
                     self.processFile(input=input, output=out)
             if depfile:
                 mk = Makefile()
@@ -483,7 +484,7 @@ class Preprocessor:
 
     def getCommandLineParser(self, unescapeDefines = False):
         escapedValue = re.compile('".*"$')
-        numberValue = re.compile('\d+$')
+        numberValue = re.compile(r'\d+$')
         def handleD(option, opt, value, parser):
             vals = value.split('=', 1)
             if len(vals) == 1:
@@ -551,7 +552,7 @@ class Preprocessor:
 
     # Variables
     def do_define(self, args):
-        m = re.match('(?P<name>\w+)(?:\s(?P<value>.*))?', args, re.U)
+        m = re.match(r'(?P<name>\w+)(?:\s(?P<value>.*))?', args, re.U)
         if not m:
             raise Preprocessor.Error(self, 'SYNTAX_DEF', args)
         val = ''
@@ -563,7 +564,7 @@ class Preprocessor:
                 pass
         self.context[m.group('name')] = val
     def do_undef(self, args):
-        m = re.match('(?P<name>\w+)$', args, re.U)
+        m = re.match(r'(?P<name>\w+)$', args, re.U)
         if not m:
             raise Preprocessor.Error(self, 'SYNTAX_DEF', args)
         if args in self.context:
@@ -599,7 +600,7 @@ class Preprocessor:
         if self.disableLevel and not replace:
             self.disableLevel += 1
             return
-        if re.match('\W', args, re.U):
+        if re.match(r'\W', args, re.U):
             raise Preprocessor.Error(self, 'INVALID_VAR', args)
         if args not in self.context:
             self.disableLevel = 1
@@ -614,7 +615,7 @@ class Preprocessor:
         if self.disableLevel and not replace:
             self.disableLevel += 1
             return
-        if re.match('\W', args, re.U):
+        if re.match(r'\W', args, re.U):
             raise Preprocessor.Error(self, 'INVALID_VAR', args)
         if args in self.context:
             self.disableLevel = 1
@@ -658,7 +659,7 @@ class Preprocessor:
             self.ifStates.pop()
     # output processing
     def do_expand(self, args):
-        lst = re.split('__(\w+)__', args, re.U)
+        lst = re.split(r'__(\w+)__', args, re.U)
         do_replace = False
         def vsubst(v):
             if v in self.context:
@@ -677,7 +678,7 @@ class Preprocessor:
         current = dict(self.filters)
         for f in filters:
             current[f] = getattr(self, 'filter_' + f)
-        filterNames = current.keys()
+        filterNames = list(current.keys())
         filterNames.sort()
         self.filters = [(fn, current[fn]) for fn in filterNames]
         return
@@ -687,7 +688,7 @@ class Preprocessor:
         for f in filters:
             if f in current:
                 del current[f]
-        filterNames = current.keys()
+        filterNames = list(current.keys())
         filterNames.sort()
         self.filters = [(fn, current[fn]) for fn in filterNames]
         return
@@ -732,7 +733,7 @@ class Preprocessor:
         args can either be a file name, or a file-like object.
         Files should be opened, and will be closed after processing.
         """
-        isName = type(args) == str or type(args) == unicode
+        isName = type(args) == str or type(args) == str
         oldCheckLineNumbers = self.checkLineNumbers
         self.checkLineNumbers = False
         if isName:
@@ -742,12 +743,12 @@ class Preprocessor:
                     args = self.applyFilters(args)
                 if not os.path.isabs(args):
                     args = os.path.join(self.context['DIRECTORY'], args)
-                args = open(args, 'rU')
+                args = open(args, 'r')
             except Preprocessor.Error:
                 raise
             except:
                 raise Preprocessor.Error(self, 'FILE_NOT_FOUND', str(args))
-        self.checkLineNumbers = bool(re.search('\.(js|jsm|java)(?:\.in)?$', args.name))
+        self.checkLineNumbers = bool(re.search(r'\.(js|jsm|java)(?:\.in)?$', args.name))
         oldFile = self.context['FILE']
         oldLine = self.context['LINE']
         oldDir = self.context['DIRECTORY']
@@ -787,7 +788,7 @@ def preprocess(includes=[sys.stdin], defines={},
     pp = Preprocessor(defines=defines,
                       marker=marker)
     for f in includes:
-        with open(f, 'rU') as input:
+        with open(f, 'r') as input:
             pp.processFile(input=input, output=output)
     return pp.includes
 
diff --git a/python/mozbuild/mozbuild/pythonutil.py b/python/mozbuild/mozbuild/pythonutil.py
index 3dba256915..f8dff1323e 100644
--- a/python/mozbuild/mozbuild/pythonutil.py
+++ b/python/mozbuild/mozbuild/pythonutil.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import os
 import sys
diff --git a/python/mozbuild/mozbuild/shellutil.py b/python/mozbuild/mozbuild/shellutil.py
index 185a970ee5..57fa09b77e 100644
--- a/python/mozbuild/mozbuild/shellutil.py
+++ b/python/mozbuild/mozbuild/shellutil.py
@@ -14,13 +14,13 @@ def _tokens2re(**tokens):
     #   (?P<name>pattern)
     # which matches the pattern and captures it in a named match group.
     # The group names and patterns are given as arguments.
-    all_tokens = '|'.join('(?P<%s>%s)' % (name, value)
-                          for name, value in tokens.iteritems())
+    all_tokens = '|'.join('(?P<{}>{})'.format(name, value)
+                          for name, value in tokens.items())
     nonescaped = r'(?<!\\)(?:%s)' % all_tokens
 
     # The final pattern matches either the above pattern, or an escaped
     # backslash, captured in the "escape" match group.
-    return re.compile('(?:%s|%s)' % (nonescaped, r'(?P<escape>\\\\)'))
+    return re.compile('(?:{}|{})'.format(nonescaped, r'(?P<escape>\\\\)'))
 
 UNQUOTED_TOKENS_RE = _tokens2re(
   whitespace=r'[\t\r\n ]+',
@@ -33,7 +33,7 @@ UNQUOTED_TOKENS_RE = _tokens2re(
 DOUBLY_QUOTED_TOKENS_RE = _tokens2re(
   quote='"',
   backslashedquote=r'\\"',
-  special='\$',
+  special=r'\$',
   backslashed=r'\\[^\\"]',
 )
 
@@ -49,7 +49,7 @@ class MetaCharacterException(Exception):
         self.char = char
 
 
-class _ClineSplitter(object):
+class _ClineSplitter:
     '''
     Parses a given command line string and creates a list of command
     and arguments, with wildcard expansion.
